﻿Type=Class
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
#Region   VERSIONS  
'	1.0
'			"Empty"
							
#End Region

#Event: Connected
#Event: Closed (Reason As String)

Sub Class_Globals
	Public ws As WebSocket
	Private CallBack As Object
	Private EventName As String
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	CallBack = vCallback
	EventName = vEventName
	ws.Initialize("ws")
End Sub

#Region  + METHODS  

#Region  + Public methods  

' Raises an event on the server. The Event parameter must include an underscore
Public Sub SendEventToServer(Event As String, Data As Map)
	Dim m As Map
	m.Initialize
	m.Put("type", "event")
	m.Put("event", "FromClient_" & Event)
	m.Put("params", Data)
	Dim jg As JSONGenerator
	jg.Initialize(m)
	ws.SendText(jg.ToString)
End Sub

#End Region

#Region  + Private methods  

Private Sub ws_TextMessage(msg As String)
	Try
		Dim jp As JSONParser
		jp.Initialize(msg)
		Dim m As Map = jp.NextObject
		Dim etype As String = m.Get("etype")
		Dim params As List = m.Get("value")
		Dim event As String = m.Get("prop")

		If etype = "runFunction" Then
			CallSub2(CallBack, EventName & event, params)
		Else If etype = "runFunctionWithResult" Then
			Dim data As Map = CallSub2(CallBack, EventName & event, params)
			Dim jg As JSONGenerator
			Dim m2 As Map = AddToMap(Array As String("type", "data"), _
														 Array As Object("data", data), Null)
			jg.Initialize(m2)
			ws.SendText(jg.ToString)
		End If
	Catch
		Log("TextMessage Error: " & LastException)
	End Try
End Sub

' Adds or updates items to a Map or creates and fills a new map.
' To create a new Map, pass Null for the ExistingMap parameter.
' KeyList and ValueList must be the same size.
private Sub AddToMap(KeyList As List, ValueList As List, ExistingMap As Map) As Map
    Private mapResult As Map : mapResult.Initialize
   
    If ExistingMap.IsInitialized Then
        mapResult = ExistingMap
    End If
   
    For i = 0 To KeyList.Size - 1
        mapResult.Put(KeyList.Get(i), ValueList.Get(i))
    Next
   
    Return mapResult
End Sub

#End Region

#End Region


#Region  + WEBSOCKET CONNECTION EVENTS  

Private Sub ws_Connected
	CallSub(CallBack, "Connected")
End Sub

Private Sub ws_Closed (Reason As String)
	CallSub2(CallBack, "Closed", Reason)
End Sub

#End Region
